//Arduino 1.8.5
/*
  xsetaseta@gmail.com
  Juan Galaz
  26/06/2019
  Medidor de inductancia
  Palencia / España
*/

#define SETFRECU 3039  //3039 original    //mayor de 120uH   3215
#define PINfrecu 12


#include <TM1638.h>
// define a module on data pin 8, clock pin 9 and strobe pin 7
TM1638 module(8, 9, 7);

    unsigned int c;
    unsigned int contador;
    unsigned int x;
    byte f1;
    
    float  ca3 = 0.150; //150nF
    float fe, he, tmp;
    
    
    char VARI[30];
    int z;

void setup()
{
  pinMode(PINfrecu, INPUT);
  Serial.begin(9600);

  Serial.println("TM1638_Medidor L");
  Serial.println("================");

  module.setupDisplay(1, 0); //luz
  module.setDisplayToString("SETA -L-", 0, 0);
  delay(1000);
}

void loop()
{
  // rutina de frecuencia
  contador = 0;
  f1 = 0;

  for (x = 0; x < SETFRECU; x++)   
  {
    if (0 == (PINB & 16))
    {
      if (f1 == 0) { f1 = 1; contador++;  }
    }
    else
    {
      if (f1 == 1) { f1 = 0; contador++;  }
    }
  }

  //___________________________________________

  c++;
  Serial.print(c); Serial.print("  Frecuencia="); Serial.println(contador);
  he = 628.3185 * contador;
  he = 1 / he;
  tmp = he * he;
  
  he = tmp / ca3;
  he = he * 1000000000000;
  Serial.print("C=150nF Inductancia= "); Serial.print(he, 2); Serial.println(" uH");
  z = he;
  sprintf(VARI, "%4d uH  ", z);
  module.setDisplayToString(VARI, 0, 0);

  delay(1000);
}
